/*--------------------*/
#define PI    radians(180.0)
#define HPI   PI * 0.5
#define TAU   PI * 2.0
#define RCPPI 1.0 / PI
#define PHI   sqrt(5.0) * 0.5 + 0.5
#define GOLDEN_ANGLE TAU / PHI / PHI
#define LOG2 log(2.0)
#define RCPLOG2 1.0 / LOG2

#define lumaCoeff       vec3(0.2125, 0.7154, 0.0721)
#define RGB_Wavelengths vec3(750.0, 570.0, 495.0)

#define air_IOR   1.0002
#define water_IOR 1.3333
#define BK7_IOR   1.5176
#define IORtoF0(IOR) pow2(abs((1.0 - IOR) / (1.0 + IOR)))

#define waterAbsorbCoeff     vec3(0.4510, 0.0867, 0.0476) / LOG2
#define waterScatterCoeff    vec3(6.9, 7.2, 7.1) * 1e-3 / LOG2

#define mieScatteringAngle   0.86