mat2 rotate(float rad) {
	return mat2(
	vec2(cos(rad), -sin(rad)),
	vec2(sin(rad),  cos(rad))
	);
}

vec2 rotateNoMat(vec2 coord, vec2 x) {
    float ns = x.y * coord.y + x.x * coord.x;
    float nc = x.x * coord.y - x.y * coord.x;
    return vec2(ns, nc);
}


#define log2(x)  log(x) / log(2.0)
#define log10(x) log(x) / log(10.0)

#define cubicSmooth(x) (x * x) * (3.0 - 2.0 * x)

#define coneAngleToSolidAngle(x) (TAU * (1.0 - cos(x)))
#define solidAngleToConeAngle(x) acos(1.0 - (x) / TAU)


vec2 sincos(float x){
    return vec2(sin(x),cos(x));
}

float almostIdentity(float x, float m, float n) {
	if (x > m) return x;

	float a = 2.0 * n - m;
	float b = 2.0 * m - 3.0 * n;
	float t = x / m;

	return (a * t + b) * t * t + n;
}